# -*- coding: utf-8 -*-
"""
Created on Wed Nov 29 16:01:51 2017

@author: apoung
"""
from numpy.linalg import norm as np_norm
from numpy import dot as np_dot

def gradient_optimal(J, DJ, u0, rho, epsilon, iterMax, store): 
    err = 1;
    iters = 0;
    u = [u0] #.copy()
    un = u0 #.copy()
    rhoL=[]
    WL = []
    while( err > epsilon and iters < iterMax) :
        rn = - DJ(un)
        rho, ok = optimal_alpha_analytique(J, DJ, rho, un, rn)
        if(ok != 1):
            raise RuntimeError(" no convergence in alpha Opt")
        w = rho * rn
        un = un + w
        if (store != 0):
            u.append(un)
        else :
            u = un
        rhoL.append(rho)
        WL.append(rn)
        err = np_norm(w)
        iters = iters + 1
        print(" iteration: {0:d}  residu: {1:7.6e}".format(iters, err))
    return u, iters, rhoL, WL

def optimal_alpha_analytique(J, DJ, alpha, uk, wk):
    ok = 1
    z = uk - uk
    w0 = DJ(z)
    Awk = DJ(wk) - w0
    alphak = np_dot(wk,wk)/np_dot(Awk,wk)
    return alphak, ok

